﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.48
@EndOfDesignText@
Sub Class_Globals
	Private astream As AsyncStreams
	Private mManager As ServerManager
End Sub

Public Sub Initialize (socket As Socket, manager As ServerManager)
	Log("New connection")
	mManager = manager
	astream.Initialize(socket.InputStream, socket.OutputStream, "astream")
	SendPage(GeneraPagina)
End Sub

Public Sub NewFrame (data() As Byte)
	Private header As String = $"--myboundary
Content-Type:image/jpeg
Content-Length:${data.Length}

"$
	astream.Write(header.Replace(CRLF,Starter.EOL).GetBytes("ASCII"))
	astream.Write(data)
	astream.Write(Starter.EOL.GetBytes("ASCII"))
End Sub

Public Sub SendPage (WebPage As String)
	Dim Page As String = "HTTP/1.0 200 OK" & CRLF & "Content-Type: text/html; charset=utf-8" & CRLF & "Content-Length: " & WebPage.Length & CRLF & CRLF & WebPage & CRLF
		
	astream.Write(Page.Replace(CRLF,Starter.EOL).GetBytes("UTF8"))
End Sub

Private Sub AStream_NewData (Buffer() As Byte)
	Dim BufferString As String = BytesToString(Buffer, 0, Buffer.Length, "ASCII")
	
	If BufferString.StartsWith("GET") Then
		For Each line As String In Regex.Split("\n", BufferString)
			If line.StartsWith("GET") Then
				Dim WebPage As String = line.Replace("GET ","").Replace(" HTTP/1.1","").Trim
				
				If WebPage="/" Then 
					' Pagina principale
					SendPage(GeneraPagina)
				Else if WebPage.ToLowerCase.EndsWith("mp3") Then 
					' Musica
					CallSub2(Main,"Play",WebPage.SubString(1))
				End If
			End If
		Next
	End If
	
End Sub

Private Sub AStream_Terminated
	AStream_Error
End Sub

Private Sub AStream_Error
	Log("Error")
	mManager.ClientDisconnected(Me)
End Sub

Public Sub GeneraPagina As String
	Dim Pg As String =$"<!doctype html>
<html>
<head>
	<title>HTML Editor - Full Version</title>
</head>
<body>
<h1>Scegli il tuo&nbsp;brano</h1>

<p>Titoli:</p>

<ul>
	<li><a href="1.mp3">Ferruccio Tagliavini - voglio vivere cos&igrave;</a></li>
	<li><a href="2.mp3">Isa Barzizza - Quel motivetto che mi piace tanto&nbsp;</a></li>
	<li>&nbsp;</li>
</ul>

<p>&nbsp;</p>
</body>
</html>
"$

Return Pg
End Sub
